=== debian/changelog ===
dlib (19.24.6+dfsg-1) unstable; urgency=medium

  * New upstream version 19.24.6+dfsg

 -- Pierre Gruet <pgt@debian.org>  Mon, 07 Oct 2024 14:49:09 +0200
