## dlib 20.0+dfsg

=== debian/changelog ===
dlib (20.0+dfsg-2) unstable; urgency=medium

  * Source-onle upload to unstable

 -- Pierre Gruet <pgt@debian.org>  Sat, 03 Jan 2026 22:23:27 +0100

dlib (20.0+dfsg-1) experimental; urgency=medium

  * New upstream version 20.0+dfsg
  * Bumping SOVERSION to 20.0
  * Raising Standards version to 4.7.3:
    - Removing Priority: optional, which is default
    - Removing R-R-R: no, which is default
  * Updating debian/copyright
  * Rewriting d/watch with version 5

 -- Pierre Gruet <pgt@debian.org>  Mon, 29 Dec 2025 11:52:41 +0100
