=== debian/control ===
--- 
+++ 
@@ -3,7 +3,6 @@
 Uploaders: Séverin Lemaignan <severin@guakamole.org>,
            Pierre Gruet <pgt@debian.org>
 Section: libs
-Priority: optional
 Build-Depends: dpkg-dev (>= 1.22.5), bzip2,
                cmake,
                debhelper-compat (= 13),
@@ -12,17 +11,16 @@
                liblapack-dev,
                libpng-dev,
                libsqlite3-dev
-Standards-Version: 4.7.0
+Standards-Version: 4.7.3
 Vcs-Browser: https://salsa.debian.org/science-team/dlib
 Vcs-Git: https://salsa.debian.org/science-team/dlib.git
 Homepage: http://dlib.net/
-Rules-Requires-Root: no
 
 Package: libdlib-dev
 Architecture: any
 Multi-Arch: same
 Section: libdevel
-Depends: libdlib19.2 (= ${binary:Version}),
+Depends: libdlib20.0 (= ${binary:Version}),
          ${misc:Depends},
          libopencv-core-dev,
          libpng-dev,
@@ -39,7 +37,7 @@
  .
  This package contains the development headers.
 
-Package: libdlib19.2
+Package: libdlib20.0
 Architecture: any
 Multi-Arch: same
 Depends: libdlib-data,
