=== debian/rules ===
--- 
+++ 
@@ -12,7 +12,7 @@
 
 CONFIG_SHARED_PATH  = config_shared
 CONFIG_STATIC_PATH  = config_static
-LIB_SOVERSION       = 19.2
+LIB_SOVERSION       = 20.0
 EXAMPLES_PATH       = debian/libdlib$(LIB_SOVERSION)/usr/share/doc/libdlib$(LIB_SOVERSION)/examples/
 
 %:
