=== debian/watch ===
Version: 5

Source: https://github.com/davisking/dlib/tags
Matching-Pattern: .*/v?(\d\S*)\.tar\.gz
Dversionmangle: auto
Filenamemangle: s/.+\/v?(\d\S*)\.tar\.gz/dlib-$1\.tar\.gz/
Oversionmangle: s/(.*)/$1+dfsg/
Update-Script: debian/orig-tar.sh

Component: models
Source: https://github.com/davisking/dlib-models/tags
Matching-Pattern: .*/v?(\d\S*)\.tar\.gz
Filenamemangle: s/.+\/v?(\d\S*)\.tar\.gz/dlib-models-$1\.tar\.gz/
Update-Script: debian/orig-models-tar.sh
Version-Schema: ignore
